Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traqsr.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 2528)
@@ -21,5 +21,5 @@
    USE trc_oce         ! share SMS/Ocean variables
    USE trdmod_oce      ! ocean variables trends
-   USE trdmod          ! ocean active tracers trends 
+   USE trdtra          ! ocean active tracers trends 
    USE in_out_manager  ! I/O manager
    USE phycst          ! physical constants
@@ -27,9 +27,11 @@
    USE iom             ! I/O manager
    USE fldread         ! read input fields
+   USE restart         ! ocean restart
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   tra_qsr        ! routine called by step.F90 (ln_traqsr=T)
+   PUBLIC   tra_qsr       ! routine called by step.F90 (ln_traqsr=T)
+   PUBLIC   tra_qsr_init  ! routine called by opa.F90
 
    !                                           !!* Namelist namtra_qsr: penetrative solar radiation
@@ -42,9 +44,10 @@
    REAL(wp), PUBLIC ::   rn_si0     = 0.35_wp   !: very near surface depth of extinction      (RGB & 2 bands)
    REAL(wp), PUBLIC ::   rn_si1     = 23.0_wp   !: deepest depth of extinction (water type I)       (2 bands)
-   REAL(wp), PUBLIC ::   rn_si2     = 61.8_wp   !: deepest depth of extinction (blue & 0.01 mg.m-3)     (RGB)
    
    ! Module variables
+   REAL(wp) ::   xsi0r                           !: inverse of rn_si0
+   REAL(wp) ::   xsi1r                           !: inverse of rn_si1
    TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_chl   ! structure of input Chl (file informations, fields read)
-   INTEGER ::   nksr   ! levels below which the light cannot penetrate ( depth larger than 391 m)
+   INTEGER, PUBLIC ::   nksr              ! levels below which the light cannot penetrate ( depth larger than 391 m)
    REAL(wp), DIMENSION(3,61) ::   rkrgb   !: tabulated attenuation coefficients for RGB absorption
 
@@ -53,7 +56,7 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -87,6 +90,4 @@
       !!              Lengaigne et al. 2007, Clim. Dyn., V28, 5, 503-516.
       !!----------------------------------------------------------------------
-      USE oce, ONLY :   ztrdt => ua   ! use ua as 3D workspace   
-      USE oce, ONLY :   ztrds => va   ! use va as 3D workspace   
       !!
       INTEGER, INTENT(in) ::   kt     ! ocean time-step
@@ -94,8 +95,11 @@
       INTEGER  ::   ji, jj, jk           ! dummy loop indices
       INTEGER  ::   irgb                 ! temporary integers
-      REAL(wp) ::   zchl, zcoef, zsi0r   ! temporary scalars
+      REAL(wp) ::   zchl, zcoef          ! temporary scalars
       REAL(wp) ::   zc0, zc1, zc2, zc3   !    -         -
+      REAL(wp) ::   zz0, zz1             !    -         -
+      REAL(wp) ::   z1_e3t, zfact        !    -         -
       REAL(wp), DIMENSION(jpi,jpj)     ::   zekb, zekg, zekr            ! 2D workspace
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ze0, ze1 , ze2, ze3, zea    ! 3D workspace
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrdt
       !!----------------------------------------------------------------------
 
@@ -104,13 +108,31 @@
          IF(lwp) WRITE(numout,*) 'tra_qsr : penetration of the surface solar radiation'
          IF(lwp) WRITE(numout,*) '~~~~~~~'
-         CALL tra_qsr_init
          IF( .NOT.ln_traqsr )   RETURN
       ENDIF
 
       IF( l_trdtra ) THEN      ! Save ta and sa trends
-         ztrdt(:,:,:) = ta(:,:,:) 
-         ztrds(:,:,:) = 0.e0
-      ENDIF
-
+         ALLOCATE( ztrdt(jpi,jpj,jpk) )   ;    ztrdt(:,:,:) = tsa(:,:,:,jp_tem)
+      ENDIF
+
+      !                                        Set before qsr tracer content field
+      !                                        ***********************************
+      IF( kt == nit000 ) THEN                     ! Set the forcing field at nit000 - 1
+         !                                        ! -----------------------------------
+         IF( ln_rstart .AND.    &                    ! Restart: read in restart file
+              & iom_varid( numror, 'qsr_hc_b', ldstop = .FALSE. ) > 0 ) THEN
+            IF(lwp) WRITE(numout,*) '          nit000-1 qsr tracer content forcing field red in the restart file'
+            zfact = 0.5e0
+            CALL iom_get( numror, jpdom_autoglo, 'qsr_hc_b', qsr_hc_b )   ! before heat content trend due to Qsr flux
+         ELSE                                           ! No restart or restart not found: Euler forward time stepping
+            zfact = 1.e0
+            qsr_hc_b(:,:,:) = 0.e0
+         ENDIF
+      ELSE                                        ! Swap of forcing field
+         !                                        ! ---------------------
+         zfact = 0.5e0
+         qsr_hc_b(:,:,:) = qsr_hc(:,:,:)
+      ENDIF
+      !                                        Compute now qsr tracer content field
+      !                                        ************************************
       
       !                                           ! ============================================== !
@@ -118,7 +140,12 @@
          !                                        ! ============================================== !
          DO jk = 1, jpkm1
-            DO jj = 2, jpjm1
+            qsr_hc(:,:,jk) = ro0cpr * ( etot3(:,:,jk) - etot3(:,:,jk+1) )
+         END DO
+         !                                        Add to the general trend
+         DO jk = 1, jpkm1
+            DO jj = 2, jpjm1 
                DO ji = fs_2, fs_jpim1   ! vector opt.
-                  ta(ji,jj,jk) = ta(ji,jj,jk) + ro0cpr * ( etot3(ji,jj,jk) - etot3(ji,jj,jk+1) ) / fse3t(ji,jj,jk) 
+                  z1_e3t = zfact / fse3t(ji,jj,jk)
+                  tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + ( qsr_hc_b(ji,jj,jk) + qsr_hc(ji,jj,jk) ) * z1_e3t
                END DO
             END DO
@@ -133,22 +160,30 @@
             !                                             ! ------------------------- !
             ! Set chlorophyl concentration
-            IF( nn_chldta ==1 ) THEN                             !*  Variable Chlorophyll
-               !
-               CALL fld_read( kt, 1, sf_chl )                         ! Read Chl data and provides it at the current time step
-               !         
+            IF( nn_chldta == 1 .OR. lk_vvl ) THEN            !*  Variable Chlorophyll or ocean volume
+               !
+               IF( nn_chldta == 1 ) THEN                             !*  Variable Chlorophyll
+                  !
+                  CALL fld_read( kt, 1, sf_chl )                         ! Read Chl data and provides it at the current time step
+                  !         
 !CDIR COLLAPSE
 !CDIR NOVERRCHK
-               DO jj = 1, jpj                                         ! Separation in R-G-B depending of the surface Chl
+                  DO jj = 1, jpj                                         ! Separation in R-G-B depending of the surface Chl
 !CDIR NOVERRCHK
-                  DO ji = 1, jpi
-                     zchl = MIN( 10. , MAX( 0.03, sf_chl(1)%fnow(ji,jj) ) )
-                     irgb = NINT( 41 + 20.*LOG10(zchl) + 1.e-15 )
-                     zekb(ji,jj) = rkrgb(1,irgb)
-                     zekg(ji,jj) = rkrgb(2,irgb)
-                     zekr(ji,jj) = rkrgb(3,irgb)
-                  END DO
-               END DO
-               !
-               zsi0r = 1.e0 / rn_si0
+                     DO ji = 1, jpi
+                        zchl = MIN( 10. , MAX( 0.03, sf_chl(1)%fnow(ji,jj,1) ) )
+                        irgb = NINT( 41 + 20.*LOG10(zchl) + 1.e-15 )
+                        zekb(ji,jj) = rkrgb(1,irgb)
+                        zekg(ji,jj) = rkrgb(2,irgb)
+                        zekr(ji,jj) = rkrgb(3,irgb)
+                     END DO
+                  END DO
+               ELSE                                            ! Variable ocean volume but constant chrlorophyll
+                  zchl = 0.05                                     ! constant chlorophyll
+                  irgb = NINT( 41 + 20.*LOG10( zchl ) + 1.e-15 )
+                  zekb(:,:) = rkrgb(1,irgb)                       ! Separation in R-G-B depending of the chlorophyll 
+                  zekg(:,:) = rkrgb(2,irgb)
+                  zekr(:,:) = rkrgb(3,irgb)
+               ENDIF
+               !
                zcoef  = ( 1. - rn_abs ) / 3.e0                        ! equi-partition in R-G-B
                ze0(:,:,1) = rn_abs  * qsr(:,:)
@@ -163,5 +198,5 @@
 !CDIR NOVERRCHK   
                      DO ji = 1, jpi
-                        zc0 = ze0(ji,jj,jk-1) * EXP( - fse3t(ji,jj,jk-1) * zsi0r     )
+                        zc0 = ze0(ji,jj,jk-1) * EXP( - fse3t(ji,jj,jk-1) * xsi0r     )
                         zc1 = ze1(ji,jj,jk-1) * EXP( - fse3t(ji,jj,jk-1) * zekb(ji,jj) )
                         zc2 = ze2(ji,jj,jk-1) * EXP( - fse3t(ji,jj,jk-1) * zekg(ji,jj) )
@@ -177,5 +212,5 @@
                !
                DO jk = 1, nksr                                        ! compute and add qsr trend to ta
-                  ta(:,:,jk) = ta(:,:,jk) + ro0cpr * ( zea(:,:,jk) - zea(:,:,jk+1) ) / fse3t(:,:,jk)
+                  qsr_hc(:,:,jk) = ro0cpr * ( zea(:,:,jk) - zea(:,:,jk+1) )
                END DO
                zea(:,:,nksr+1:jpk) = 0.e0     ! below 400m set to zero
@@ -184,5 +219,5 @@
             ELSE                                                 !*  Constant Chlorophyll
                DO jk = 1, nksr
-                  ta(:,:,jk) = ta(:,:,jk) + etot3(:,:,jk) * qsr(:,:)
+                  qsr_hc(:,:,jk) =  etot3(:,:,jk) * qsr(:,:)
                END DO
             ENDIF
@@ -193,22 +228,58 @@
             !                                             ! ------------------------- !
             !
-            DO jk = 1, nksr
-               DO jj = 2, jpjm1
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
-                     ta(ji,jj,jk) = ta(ji,jj,jk) + etot3(ji,jj,jk) * qsr(ji,jj)
-                  END DO
+            IF( lk_vvl ) THEN                                  !* variable volume
+               zz0   =        rn_abs   * ro0cpr
+               zz1   = ( 1. - rn_abs ) * ro0cpr
+               DO jk = 1, nksr                    ! solar heat absorbed at T-point in the top 400m 
+                  DO jj = 2, jpjm1
+                     DO ji = 2, jpim1
+                        zc0 = zz0 * EXP( -fsdepw(ji,jj,jk  )*xsi0r ) + zz1 * EXP( -fsdepw(ji,jj,jk  )*xsi1r )
+                        zc1 = zz0 * EXP( -fsdepw(ji,jj,jk+1)*xsi0r ) + zz1 * EXP( -fsdepw(ji,jj,jk+1)*xsi1r )
+                        qsr_hc(ji,jj,jk) = qsr(ji,jj) * ( zc0*tmask(ji,jj,jk) - zc1*tmask(ji,jj,jk+1) ) 
+                     END DO
+                  END DO
+               END DO
+            ELSE                                               !* constant volume: coef. computed one for all
+               DO jk = 1, nksr
+                  DO jj = 2, jpjm1
+                     DO ji = fs_2, fs_jpim1   ! vector opt.
+                        qsr_hc(ji,jj,jk) =  etot3(ji,jj,jk) * qsr(ji,jj)
+                     END DO
+                  END DO
+               END DO
+               !
+            ENDIF
+            !
+         ENDIF
+         !
+         !                                        Add to the general trend
+         DO jk = 1, nksr
+            DO jj = 2, jpjm1 
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  z1_e3t = zfact / fse3t(ji,jj,jk)
+                  tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + ( qsr_hc_b(ji,jj,jk) + qsr_hc(ji,jj,jk) ) * z1_e3t
                END DO
             END DO
-            !
-         ENDIF
+         END DO
+         !
+      ENDIF
+      !
+      IF( lrst_oce ) THEN   !                  Write in the ocean restart file
+         !                                     *******************************
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'qsr tracer content forcing field written in ocean restart file ',   &
+            &                    'at it= ', kt,' date= ', ndastp
+         IF(lwp) WRITE(numout,*) '~~~~'
+         CALL iom_rstput( kt, nitrst, numrow, 'qsr_hc_b', qsr_hc )
          !
       ENDIF
 
       IF( l_trdtra ) THEN     ! qsr tracers trends saved for diagnostics
-         ztrdt(:,:,:) = ta(:,:,:) - ztrdt(:,:,:)
-         CALL trd_mod( ztrdt, ztrds, jptra_trd_qsr, 'TRA', kt )
+         ztrdt(:,:,:) = tsa(:,:,:,jp_tem) - ztrdt(:,:,:)
+         CALL trd_tra( kt, 'TRA', jp_tem, jptra_trd_qsr, ztrdt )
+         DEALLOCATE( ztrdt )
       ENDIF
       !                       ! print mean trends (used for debugging)
-      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' qsr  - Ta: ', mask1=tmask, clinfo3='tra-ta' )
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' qsr  - Ta: ', mask1=tmask, clinfo3='tra-ta' )
       !
    END SUBROUTINE tra_qsr
@@ -235,7 +306,7 @@
       INTEGER  ::   irgb, ierror          ! temporary integer
       INTEGER  ::   ioptio, nqsr          ! temporary integer
-      REAL(wp) ::   zc0  , zc1            ! temporary scalars
+      REAL(wp) ::   zc0  , zc1, zcoef     ! temporary scalars
       REAL(wp) ::   zc2  , zc3  , zchl    !    -         -
-      REAL(wp) ::   zsi0r, zsi1r, zcoef   !    -         -
+      REAL(wp) ::   zz0  , zz1            !    -         -
       REAL(wp), DIMENSION(jpi,jpj)     ::   zekb, zekg, zekr              ! 2D workspace
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ze0 , ze1 , ze2 , ze3 , zea   ! 3D workspace
@@ -244,5 +315,5 @@
       TYPE(FLD_N)        ::   sn_chl   ! informations about the chlorofyl field to be read
       NAMELIST/namtra_qsr/  sn_chl, cn_dir, ln_traqsr, ln_qsr_rgb, ln_qsr_2bd, ln_qsr_bio,   &
-         &                  nn_chldta, rn_abs, rn_si0, rn_si1, rn_si2
+         &                  nn_chldta, rn_abs, rn_si0, rn_si1
       !!----------------------------------------------------------------------
 
@@ -269,5 +340,4 @@
          WRITE(numout,*) '      RGB & 2 bands: shortess depth of extinction  rn_si0 = ', rn_si0
          WRITE(numout,*) '      2 bands: longest depth of extinction         rn_si1 = ', rn_si1
-         WRITE(numout,*) '      3 bands: longest depth of extinction         rn_si2 = ', rn_si2
       ENDIF
 
@@ -284,12 +354,7 @@
          IF( ln_qsr_bio  )   ioptio = ioptio + 1
          !
-         IF( ioptio /= 1 ) THEN
-            ln_qsr_rgb = .TRUE.
-            nn_chldta  = 0
-            ln_qsr_2bd = .FALSE.
-            ln_qsr_bio = .FALSE.
-            CALL ctl_warn( '          Choose ONE type of light penetration in namelist namtra_qsr',   &
-           &               ' otherwise, we force the model to run with RGB light penetration' )
-         ENDIF
+         IF( ioptio /= 1 ) &
+            CALL ctl_stop( '          Choose ONE type of light penetration in namelist namtra_qsr',  &
+            &              ' 2 bands, 3 RGB bands or bio-model light penetration' )
          !
          IF( ln_qsr_rgb .AND. nn_chldta == 0 )   nqsr =  1 
@@ -300,7 +365,7 @@
          IF(lwp) THEN                   ! Print the choice
             WRITE(numout,*)
-            IF( nqsr ==  1 )   WRITE(numout,*) '         R-G-B  light penetration - Constant Chlorophyll'
-            IF( nqsr ==  2 )   WRITE(numout,*) '         R-G-B  light penetration - Chl data '
-            IF( nqsr ==  3 )   WRITE(numout,*) '         2 band light penetration'
+            IF( nqsr ==  1 )   WRITE(numout,*) '         R-G-B   light penetration - Constant Chlorophyll'
+            IF( nqsr ==  2 )   WRITE(numout,*) '         R-G-B   light penetration - Chl data '
+            IF( nqsr ==  3 )   WRITE(numout,*) '         2 bands light penetration'
             IF( nqsr ==  4 )   WRITE(numout,*) '         bio-model light penetration'
          ENDIF
@@ -311,19 +376,18 @@
          !                       ! ===================================== !
          !
-         zsi0r = 1.e0 / rn_si0
-         zsi1r = 1.e0 / rn_si1
+         xsi0r = 1.e0 / rn_si0
+         xsi1r = 1.e0 / rn_si1
          !                                ! ---------------------------------- !
          IF( ln_qsr_rgb ) THEN            !  Red-Green-Blue light penetration  !
             !                             ! ---------------------------------- !
             !
-            !                                ! level of light extinction
-            nksr = trc_oce_ext_lev( rn_si2, 0.33e2 )
-            IF(lwp) THEN
-               WRITE(numout,*)
-               WRITE(numout,*) '        level max of computation of qsr = ', nksr, ' ref depth = ', gdepw_0(nksr+1), ' m'
-            ENDIF
-            !
             CALL trc_oce_rgb( rkrgb )           !* tabulated attenuation coef.
-!!gm            CALL trc_oce_rgb_read( rkrgb )           !* tabulated attenuation coef.
+            !
+            !                                   !* level of light extinction
+            IF(  ln_sco ) THEN   ;   nksr = jpkm1
+            ELSE                 ;   nksr = trc_oce_ext_lev( r_si2, 0.33e2 )
+            ENDIF
+
+            IF(lwp) WRITE(numout,*) '        level of light extinction = ', nksr, ' ref depth = ', gdepw_0(nksr+1), ' m'
             !
             IF( nn_chldta == 1 ) THEN           !* Chl data : set sf_chl structure
@@ -334,6 +398,6 @@
                   CALL ctl_stop( 'tra_qsr_init: unable to allocate sf_chl structure' )   ;   RETURN
                ENDIF
-               ALLOCATE( sf_chl(1)%fnow(jpi,jpj)   )
-               ALLOCATE( sf_chl(1)%fdta(jpi,jpj,2) )
+               ALLOCATE( sf_chl(1)%fnow(jpi,jpj,1)   )
+               IF( sn_chl%ln_tint )ALLOCATE( sf_chl(1)%fdta(jpi,jpj,1,2) )
                !                                        ! fill sf_chl with sn_chl and control print
                CALL fld_fill( sf_chl, (/ sn_chl /), cn_dir, 'tra_qsr_init',   &
@@ -343,41 +407,45 @@
                IF(lwp) WRITE(numout,*)
                IF(lwp) WRITE(numout,*) '        Constant Chlorophyll concentration = 0.05'
-               IF(lwp) WRITE(numout,*) '        light distribution computed once for all'
-               !
-               zchl = 0.05                                 ! constant chlorophyll
-               irgb = NINT( 41 + 20.*LOG10(zchl) + 1.e-15 )
-               zekb(:,:) = rkrgb(1,irgb)                   ! Separation in R-G-B depending of the chlorophyl concentration
-               zekg(:,:) = rkrgb(2,irgb)
-               zekr(:,:) = rkrgb(3,irgb)
-               !
-               zcoef = ( 1. - rn_abs ) / 3.e0              ! equi-partition in R-G-B
-               ze0(:,:,1) = rn_abs
-               ze1(:,:,1) = zcoef
-               ze2(:,:,1) = zcoef 
-               ze3(:,:,1) = zcoef
-               zea(:,:,1) = tmask(:,:,1)                   ! = ( ze0+ze1+z2+ze3 ) * tmask
+               IF( lk_vvl ) THEN                   ! variable volume
+                  IF(lwp) WRITE(numout,*) '        key_vvl: light distribution will be computed at each time step'
+               ELSE                                ! constant volume: computes one for all
+                  IF(lwp) WRITE(numout,*) '        fixed volume: light distribution computed one for all'
+                  !
+                  zchl = 0.05                                 ! constant chlorophyll
+                  irgb = NINT( 41 + 20.*LOG10(zchl) + 1.e-15 )
+                  zekb(:,:) = rkrgb(1,irgb)                   ! Separation in R-G-B depending of the chlorophyll 
+                  zekg(:,:) = rkrgb(2,irgb)
+                  zekr(:,:) = rkrgb(3,irgb)
+                  !
+                  zcoef = ( 1. - rn_abs ) / 3.e0              ! equi-partition in R-G-B
+                  ze0(:,:,1) = rn_abs
+                  ze1(:,:,1) = zcoef
+                  ze2(:,:,1) = zcoef 
+                  ze3(:,:,1) = zcoef
+                  zea(:,:,1) = tmask(:,:,1)                   ! = ( ze0+ze1+z2+ze3 ) * tmask
                
-               DO jk = 2, nksr+1
+                  DO jk = 2, nksr+1
 !CDIR NOVERRCHK
-                  DO jj = 1, jpj
+                     DO jj = 1, jpj
 !CDIR NOVERRCHK   
-                     DO ji = 1, jpi
-                        zc0 = ze0(ji,jj,jk-1) * EXP( - fse3t(ji,jj,jk-1) * zsi0r     )
-                        zc1 = ze1(ji,jj,jk-1) * EXP( - fse3t(ji,jj,jk-1) * zekb(ji,jj) )
-                        zc2 = ze2(ji,jj,jk-1) * EXP( - fse3t(ji,jj,jk-1) * zekg(ji,jj) )
-                        zc3 = ze3(ji,jj,jk-1) * EXP( - fse3t(ji,jj,jk-1) * zekr(ji,jj) )
-                        ze0(ji,jj,jk) = zc0                 
-                        ze1(ji,jj,jk) = zc1
-                        ze2(ji,jj,jk) = zc2     
-                        ze3(ji,jj,jk) = zc3
-                        zea(ji,jj,jk) = ( zc0 + zc1 + zc2 + zc3 ) * tmask(ji,jj,jk)
-                     END DO
-                  END DO
-               END DO 
-               !
-               DO jk = 1, nksr
-                  etot3(:,:,jk) = ro0cpr * ( zea(:,:,jk) - zea(:,:,jk+1) ) / fse3t(:,:,jk)
-               END DO
-               etot3(:,:,nksr+1:jpk) = 0.e0                ! below 400m set to zero
+                        DO ji = 1, jpi
+                           zc0 = ze0(ji,jj,jk-1) * EXP( - fse3t_0(ji,jj,jk-1) * xsi0r     )
+                           zc1 = ze1(ji,jj,jk-1) * EXP( - fse3t_0(ji,jj,jk-1) * zekb(ji,jj) )
+                           zc2 = ze2(ji,jj,jk-1) * EXP( - fse3t_0(ji,jj,jk-1) * zekg(ji,jj) )
+                           zc3 = ze3(ji,jj,jk-1) * EXP( - fse3t_0(ji,jj,jk-1) * zekr(ji,jj) )
+                           ze0(ji,jj,jk) = zc0
+                           ze1(ji,jj,jk) = zc1
+                           ze2(ji,jj,jk) = zc2
+                           ze3(ji,jj,jk) = zc3
+                           zea(ji,jj,jk) = ( zc0 + zc1 + zc2 + zc3 ) * tmask(ji,jj,jk)
+                        END DO
+                     END DO
+                  END DO 
+                  !
+                  DO jk = 1, nksr
+                     etot3(:,:,jk) = ro0cpr * ( zea(:,:,jk) - zea(:,:,jk+1) ) 
+                  END DO
+                  etot3(:,:,nksr+1:jpk) = 0.e0                ! below 400m set to zero
+               ENDIF
             ENDIF
             !
@@ -391,18 +459,24 @@
             IF(lwp) THEN
                WRITE(numout,*)
-               WRITE(numout,*) '        level max of computation of qsr = ', nksr, ' ref depth = ', gdepw_0(nksr+1), ' m'
-            ENDIF
-            !
-            DO jk = 1, nksr                    !*  solar heat absorbed at T-point computed once for all
-               DO jj = 1, jpj                              ! top 400 meters
-                  DO ji = 1, jpi
-                     zc0 = rn_abs * EXP( -fsdepw(ji,jj,jk  )*zsi0r ) + (1.-rn_abs) * EXP( -fsdepw(ji,jj,jk  )*zsi1r )
-                     zc1 = rn_abs * EXP( -fsdepw(ji,jj,jk+1)*zsi0r ) + (1.-rn_abs) * EXP( -fsdepw(ji,jj,jk+1)*zsi1r )
-                     etot3(ji,jj,jk) = ro0cpr * (  zc0 * tmask(ji,jj,jk) - zc1 * tmask(ji,jj,jk+1)  ) / fse3t(ji,jj,jk)
-                  END DO
-               END DO
-            END DO 
-            etot3(:,:,nksr+1:jpk) = 0.e0                   ! below 400m set to zero
-            !
+            IF(lwp) WRITE(numout,*) '        level of light extinction = ', nksr, ' ref depth = ', gdepw_0(nksr+1), ' m'
+            ENDIF
+            !
+            IF( lk_vvl ) THEN                   ! variable volume
+               IF(lwp) WRITE(numout,*) '        key_vvl: light distribution will be computed at each time step'
+            ELSE                                ! constant volume: computes one for all
+               zz0 =        rn_abs   * ro0cpr
+               zz1 = ( 1. - rn_abs ) * ro0cpr
+               DO jk = 1, nksr                    !*  solar heat absorbed at T-point computed once for all
+                  DO jj = 1, jpj                              ! top 400 meters
+                     DO ji = 1, jpi
+                        zc0 = zz0 * EXP( -fsdepw(ji,jj,jk  )*xsi0r ) + zz1 * EXP( -fsdepw(ji,jj,jk  )*xsi1r )
+                        zc1 = zz0 * EXP( -fsdepw(ji,jj,jk+1)*xsi0r ) + zz1 * EXP( -fsdepw(ji,jj,jk+1)*xsi1r )
+                        etot3(ji,jj,jk) = (  zc0 * tmask(ji,jj,jk) - zc1 * tmask(ji,jj,jk+1)  ) 
+                     END DO
+                  END DO
+               END DO
+               etot3(:,:,nksr+1:jpk) = 0.e0                   ! below 400m set to zero
+               !
+            ENDIF
          ENDIF
          !                       ! ===================================== !
